CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


  'LCD is 320x240 giving 20x15 tiles
  cols = 20
  rows = 15
  screensize = cols * rows

CON  'Constants for Graphics Demo 
  _stack = ($3000 + $3000 + 200+2*screensize) >> 2   'accomodate display memory and stack  
  x_tiles = 16
  y_tiles = 12

  paramcount = 14  
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 2

  GraphicsXOffset=2
  GraphicsYOffset=2
  
  RxPin = 2
  TxPin =  3
  Baud = 9600
VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr
 
  byte ct
  byte v
  byte hist[60]
  Byte rx
  Byte RxBuff[15]
  Byte ID[3]
  Byte VMin, VMax, Val
  Byte LineOne[10], LineTwo[10], LineThree[10]
  Byte Units[5]

OBJ    'Objects for Graphics Demo
  
  gr    : "graphics"
  ss    : "Simple_Serial"
  lcd : "PTP_LcdDriver"  'Modified to drive 3.5" TFT    

pub Main
  'Start up Display
  LineOne := string("TEST")
  hist[0] := 0
  hist[1] := 2
  hist[2] := 3
  hist[3] := 4
  hist[4] := 5
  hist[5] := 6
  {{hist[6] := 7
  hist[7] := 6
  hist[8] := 6
  hist[9] := 5
  {{hist[10] := 4
  hist[11] := 3
  hist[12] := 2
  hist[13] := 4
  hist[14] := 6
  hist[15] := 8
  hist[16] := 12
  hist[17] := 16
  hist[18] := 14
  hist[19] := 50
  {{hist[20] := 60
  hist[21] := 70
  hist[22] := 80
  hist[23] := 90
  hist[24] := 99
  hist[25] := 80
  hist[26] := 85
  hist[27] := 70
  hist[28] := 65
  hist[29] := 60
  hist[30] := 0  
  {{
  hist[31] := 2
  hist[32] := 3
  hist[33] := 4
  hist[34] := 5
  hist[35] := 6
  hist[36] := 7
  hist[37] := 6
  hist[38] := 6
  hist[39] := 5
  hist[40] := 4
  hist[41] := 3
  hist[42] := 2
  hist[43] := 4
  hist[44] := 6
  hist[45] := 8
  hist[46] := 12
  hist[47] := 16
  hist[48] := 14
  hist[49] := 50
  hist[50] := 60
  hist[51] := 70
  hist[52] := 80
  hist[53] := 90
  hist[54] := 99
  hist[55] := 80
  hist[56] := 85
  hist[57] := 70
  hist[58] := 65
  hist[59] := 60 }}   
          

  'clear screen
  print($100)

  'start driver
  lcd_enable:=1
  lcd_videobase := @screen
  lcd_colorbase := @vgacolors
  lcd_backlight:=1  '1=bright, 16=medium, 32=dark
  lcd.start(@lcd_status)

  ss.init(RxPin, TxPin, Baud)

 {{ repeat
    
    repeat while Rx <>= "$"
       Rx := ss.Rx 
    ct := 0
    repeat 3
       ID[ct++] := ss.Rx
    if ID[0] == "L"
       if ID[1] == "I"
          if ID[2] == "1"
             callLineOne             
          if ID[2] == "2"
             callLineTwo
          if ID[2] == "3"
              callLineThree
              
    if ID[0] == "M"
       if ID[1] == "I"
          if ID[2] == "N"
             callUpdateMin
          
    if ID[0] == "M"
       if ID[1] == "A"
          if ID[2] == "X"
             callUpdateMax

    if ID[0] == "V"
       if ID[1] == "A"
          if ID[2] == "L"
              callUpdateVal

    if ID[0] == "U"
       if ID[1] == "N"
          if ID [2] == "I"
              callUpdateUnits     
          
          
  col:=1}}
  callUpdateText       

  
  waitcnt(cnt+clkfreq)

  GraphicsDemo


PUB GraphicsDemo|i,j,k,dx,dy, kk, pp, pq, rr, numx, numchr,GraphicsColor 
  'init colors
  GraphicsColor:=16 'Using this color for graphics colors
  'Trying to sorta match the color gradient in the real version...
  vgacolors[GraphicsColor+0]:= $0CFC0000+%%0210_0000
  vgacolors[GraphicsColor+1]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+2]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+3]:= $0CFC0000+%%1210_0000  
  vgacolors[GraphicsColor+4]:= $0CFC0000+%%1220_0000     
  vgacolors[GraphicsColor+5]:= $0CFC0000+%%1220_0000  
  vgacolors[GraphicsColor+6]:= $0CFC0000+%%1120_0000  
  vgacolors[GraphicsColor+7]:= $0CFC0000+%%2120_0000  
  vgacolors[GraphicsColor+8]:= $0CFC0000+%%2130_0000  
  vgacolors[GraphicsColor+9]:= $0CFC0000+%%2030_0000  
  vgacolors[GraphicsColor+10]:=$0CFC0000+%%3030_0000  
  vgacolors[GraphicsColor+11]:=$0CFC0000+%%3030_0000  
 
  'init tile screen
  repeat dx from 0 to x_tiles - 1
    repeat dy from 4 to y_tiles - 1
      screen[(dy+GraphicsYOffset) * cols + dx+GraphicsXOffset]:= display_base >> 6 + dy + dx * y_tiles +(GraphicsColor+dy)<<10'((GraphicsColor+dy) & $3F)<<10



  
  gr.start


  gr.setup(16, 12, 128, 96, bitmap_base)

  

                             k:=0
  repeat

    'clear bitmap
    gr.clear
    gr.colorwidth(6,1)
    gr.color(2)
    gr.arc(-50,-40,55,55,0,300,20,2)
    ct := 0
    repeat 5
       gr.arc(-50,-40,55-ct,55-ct++,0,300,20,4)
       gr.arc(-50,-40,50-ct,50-ct++,0,300,2,4)


    v:= k*250/100  
    
    gr.colorwidth(3,4)
    gr.plot(-50,-40)
      

    gr.line(-50+sin(v-165,60), -40+cos (v-165,60))
    'copy bitmap to display

    gr.colorwidth(2,1)
    gr.plot(19,-82)
    gr.line(19,20)
    gr.plot(18,-82)
    gr.line(120,-82)
    ct:=0
    gr.colorwidth(3,1)
{{    repeat 15
      gr.plot(ct*3/2+20,-80)
      gr.line(ct*3/2+20,-80 + hist[ct+1])
      if ct ==0
        hist[59] := hist[ct]
      hist[ct] := hist[ct + 1]

      ct++}}
    gr.copy(display_base)  

    
    'increment counter that makes everything change
    k++


    

PUB sin(degree, range) :s |c,z,angle
angle := (degree*91)~>2
c:= angle & $800
z:= angle & $1000
if c
   angle := -angle
angle |= $E000>>1
angle <<= 1
s := word[angle]
if z
  s := -s
return (s*range)~>16

PUB cos(degree,range)
return sin(degree+90,range)
PRI PrintStr(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    print(byte[stringptr++])

PUB print(c) | i, k

  case c
    $00..$FF:           'character?
      k := color << 1 + c & 1
      i := k << 10 + $200 + c & $FE
      screen[row * cols + col] := i
      screen[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@screen, $220, screensize)
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $10D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line
PUB callLineOne
  callGetText
  ByteMove(@LineOne, @RxBuff, Ct-1)
  callUpdateText  
PUB callLineTwo

PUB callLineThree

PUB callupdateMin

PUB callUpdateMax

PUB callUpdateVal

PUB callUpdateUnits

PUB callUpdateText
print($100)
printStr(LineOne)
newLine
printStr(LineTwo)
newLine
printStr(LineThree)

PUB callGetText
  longfill(Rxbuff,20,0)
  ct := 0
  repeat until Rx:= "*"
    RxBuff[Ct++] := ss.Rx
PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
'      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
'    wordfill(@screen[(rows-2)*cols], $200, cols<<1)


' Data

DAT

vgacolors               long
                        long    $F00CF00C'$F00CF00C       'blue background with yellow letters
                        long    $F0F00C0C'$F0F00C0C
                        long    $08A808A8       'green
                        long    $0808A8A8
                        long    $50005000       'blue
                        long    $50500000
                        long    $FC00FC00       'white
                        long    $FCFC0000
                        long    $FF80FF80       'red/white
                        long    $FFFF8080
                        long    $FF20FF20       'green/white
                        long    $FFFF2020
                        long    $FF28FF28       'cyan/white
                        long    $FFFF2828
                        long    $00A800A8       'grey/black
                        long    $0000A8A8
                        long    $0CFCC000      'Colors for Graphics